Blame


1 0e673013 2019-01-02 stsp #!/bin/sh
2 0e673013 2019-01-02 stsp #
3 5aa81393 2020-01-06 stsp # Copyright (c) 2019, 2020 Stefan Sperling <stsp@openbsd.org>
4 0e673013 2019-01-02 stsp #
5 0e673013 2019-01-02 stsp # Permission to use, copy, modify, and distribute this software for any
6 0e673013 2019-01-02 stsp # purpose with or without fee is hereby granted, provided that the above
7 0e673013 2019-01-02 stsp # copyright notice and this permission notice appear in all copies.
8 0e673013 2019-01-02 stsp #
9 0e673013 2019-01-02 stsp # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
10 0e673013 2019-01-02 stsp # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
11 0e673013 2019-01-02 stsp # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
12 0e673013 2019-01-02 stsp # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
13 0e673013 2019-01-02 stsp # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
14 0e673013 2019-01-02 stsp # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
15 0e673013 2019-01-02 stsp # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
16 0e673013 2019-01-02 stsp
17 0b2899f8 2019-08-18 stsp export GIT_AUTHOR_NAME="Flan Hacker"
18 0b2899f8 2019-08-18 stsp export GIT_AUTHOR_EMAIL="flan_hacker@openbsd.org"
19 0b2899f8 2019-08-18 stsp export GIT_COMMITTER_NAME="$GIT_AUTHOR_NAME"
20 0b2899f8 2019-08-18 stsp export GIT_COMMITTER_EMAIL="$GIT_AUTHOR_EMAIL"
21 0b2899f8 2019-08-18 stsp export GOT_AUTHOR="$GIT_AUTHOR_NAME <$GIT_AUTHOR_EMAIL>"
22 82f6abb8 2019-08-14 stsp export GOT_AUTHOR_8="flan_hac"
23 e600f124 2021-03-21 stsp export GOT_AUTHOR_11="flan_hacker"
24 b1ebc001 2019-08-13 stsp export GOT_LOG_DEFAULT_LIMIT=0
25 11f4fa81 2020-10-01 stsp export GOT_TEST_ROOT="/tmp"
26 c3754a5b 2019-05-10 stsp
27 7b67836a 2019-05-10 stsp export MALLOC_OPTIONS=S
28 7b67836a 2019-05-10 stsp
29 f6cae3ed 2020-09-13 naddy git_init()
30 0e673013 2019-01-02 stsp {
31 0b2899f8 2019-08-18 stsp git init -q "$1"
32 78caff98 2021-09-30 stsp
33 78caff98 2021-09-30 stsp # Switch the default branch to match our test expectations if needed.
34 78caff98 2021-09-30 stsp # Only need to change HEAD since 'git init' did not create any refs.
35 78caff98 2021-09-30 stsp # Relying on implementation details of 'git init' is no problem for us.
36 78caff98 2021-09-30 stsp # We want to be alerted when Git changes fundamental assumptions such
37 78caff98 2021-09-30 stsp # as what an empty repository looks like and where the default branch
38 78caff98 2021-09-30 stsp # is set. In such cases Got's own tooling might well need to change
39 78caff98 2021-09-30 stsp # its behaviour, too, and our tests should fail.
40 78caff98 2021-09-30 stsp # TODO: Update all tests to assume 'main' instead of 'master' and
41 78caff98 2021-09-30 stsp # switch to main here, to match Got's own default.
42 78caff98 2021-09-30 stsp echo "ref: refs/heads/master" > "$1/.git/HEAD"
43 0e673013 2019-01-02 stsp }
44 0e673013 2019-01-02 stsp
45 f6cae3ed 2020-09-13 naddy maybe_pack_repo()
46 b32c4525 2020-01-05 stsp {
47 b32c4525 2020-01-05 stsp local repo="$1"
48 b32c4525 2020-01-05 stsp if [ -n "$GOT_TEST_PACK" ]; then
49 0a26275f 2022-01-03 stsp (cd $repo && gotadmin pack -a > /dev/null)
50 6fa5c67c 2022-01-03 stsp (cd $repo && gotadmin cleanup -a -q)
51 b32c4525 2020-01-05 stsp fi
52 b32c4525 2020-01-05 stsp }
53 b32c4525 2020-01-05 stsp
54 f6cae3ed 2020-09-13 naddy git_commit()
55 0e673013 2019-01-02 stsp {
56 0e673013 2019-01-02 stsp local repo="$1"
57 0e673013 2019-01-02 stsp shift
58 0b2899f8 2019-08-18 stsp (cd $repo && git commit --author="$GOT_AUTHOR" -q -a "$@")
59 b32c4525 2020-01-05 stsp maybe_pack_repo $repo
60 0e673013 2019-01-02 stsp }
61 0e673013 2019-01-02 stsp
62 f6cae3ed 2020-09-13 naddy git_rm()
63 512f0d0e 2019-01-02 stsp {
64 512f0d0e 2019-01-02 stsp local repo="$1"
65 512f0d0e 2019-01-02 stsp shift
66 512f0d0e 2019-01-02 stsp (cd $repo && git rm -q "$@")
67 512f0d0e 2019-01-02 stsp }
68 512f0d0e 2019-01-02 stsp
69 f6cae3ed 2020-09-13 naddy git_show_head()
70 9c4b8182 2019-01-02 stsp {
71 9c4b8182 2019-01-02 stsp local repo="$1"
72 9c4b8182 2019-01-02 stsp (cd $repo && git show --no-patch --pretty='format:%H')
73 9c4b8182 2019-01-02 stsp }
74 9c4b8182 2019-01-02 stsp
75 f6cae3ed 2020-09-13 naddy git_show_branch_head()
76 db32465d 2020-02-07 stsp {
77 db32465d 2020-02-07 stsp local repo="$1"
78 db32465d 2020-02-07 stsp local branch="$2"
79 db32465d 2020-02-07 stsp (cd $repo && git show --no-patch --pretty='format:%H' $branch)
80 db32465d 2020-02-07 stsp }
81 db32465d 2020-02-07 stsp
82 db32465d 2020-02-07 stsp
83 f6cae3ed 2020-09-13 naddy git_show_author_time()
84 bcb49d15 2019-08-14 stsp {
85 bcb49d15 2019-08-14 stsp local repo="$1"
86 01073a5d 2019-08-22 stsp local object="$2"
87 01073a5d 2019-08-22 stsp (cd $repo && git show --no-patch --pretty='format:%at' $object)
88 bcb49d15 2019-08-14 stsp }
89 bcb49d15 2019-08-14 stsp
90 f6cae3ed 2020-09-13 naddy git_show_tagger_time()
91 8e7bd50a 2019-08-22 stsp {
92 8e7bd50a 2019-08-22 stsp local repo="$1"
93 8e7bd50a 2019-08-22 stsp local tag="$2"
94 8e7bd50a 2019-08-22 stsp (cd $repo && git cat-file tag $tag | grep ^tagger | \
95 8e7bd50a 2019-08-22 stsp sed -e "s/^tagger $GOT_AUTHOR//" | cut -d' ' -f2)
96 8e7bd50a 2019-08-22 stsp }
97 8e7bd50a 2019-08-22 stsp
98 f6cae3ed 2020-09-13 naddy git_show_parent_commit()
99 818c7501 2019-07-11 stsp {
100 818c7501 2019-07-11 stsp local repo="$1"
101 70551d57 2020-04-24 stsp local commit="$2"
102 70551d57 2020-04-24 stsp (cd $repo && git show --no-patch --pretty='format:%P' $commit)
103 818c7501 2019-07-11 stsp }
104 818c7501 2019-07-11 stsp
105 f6cae3ed 2020-09-13 naddy git_show_tree()
106 03415a1a 2019-06-02 stsp {
107 03415a1a 2019-06-02 stsp local repo="$1"
108 03415a1a 2019-06-02 stsp (cd $repo && git show --no-patch --pretty='format:%T')
109 03415a1a 2019-06-02 stsp }
110 03415a1a 2019-06-02 stsp
111 f6cae3ed 2020-09-13 naddy trim_obj_id()
112 818c7501 2019-07-11 stsp {
113 9439a990 2020-09-16 naddy local trimcount=$1
114 9439a990 2020-09-16 naddy local id=$2
115 818c7501 2019-07-11 stsp
116 9439a990 2020-09-16 naddy local pat=""
117 9439a990 2020-09-16 naddy while [ "$trimcount" -gt 0 ]; do
118 818c7501 2019-07-11 stsp pat="[0-9a-f]$pat"
119 9439a990 2020-09-16 naddy trimcount=$((trimcount - 1))
120 818c7501 2019-07-11 stsp done
121 818c7501 2019-07-11 stsp
122 818c7501 2019-07-11 stsp echo ${id%$pat}
123 818c7501 2019-07-11 stsp }
124 818c7501 2019-07-11 stsp
125 f6cae3ed 2020-09-13 naddy git_commit_tree()
126 03415a1a 2019-06-02 stsp {
127 03415a1a 2019-06-02 stsp local repo="$1"
128 03415a1a 2019-06-02 stsp local msg="$2"
129 03415a1a 2019-06-02 stsp local tree="$3"
130 03415a1a 2019-06-02 stsp (cd $repo && git commit-tree -m "$msg" "$tree")
131 03415a1a 2019-06-02 stsp }
132 03415a1a 2019-06-02 stsp
133 f0fd0aaf 2021-09-14 stsp git_fsck()
134 f0fd0aaf 2021-09-14 stsp {
135 f0fd0aaf 2021-09-14 stsp local testroot="$1"
136 f0fd0aaf 2021-09-14 stsp local repo="$2"
137 f0fd0aaf 2021-09-14 stsp
138 f0fd0aaf 2021-09-14 stsp (cd $repo && git fsck --strict \
139 f0fd0aaf 2021-09-14 stsp > $testroot/fsck.stdout 2> $testroot/fsck.stderr)
140 49c543a6 2022-03-31 naddy ret=$?
141 49c543a6 2022-03-31 naddy if [ $ret -ne 0 ]; then
142 f0fd0aaf 2021-09-14 stsp echo -n "git fsck: "
143 f0fd0aaf 2021-09-14 stsp cat $testroot/fsck.stderr
144 f0fd0aaf 2021-09-14 stsp echo "git fsck failed; leaving test data in $testroot"
145 f0fd0aaf 2021-09-14 stsp return 1
146 f0fd0aaf 2021-09-14 stsp fi
147 f0fd0aaf 2021-09-14 stsp
148 f0fd0aaf 2021-09-14 stsp return 0
149 f0fd0aaf 2021-09-14 stsp }
150 f0fd0aaf 2021-09-14 stsp
151 f6cae3ed 2020-09-13 naddy make_test_tree()
152 0e673013 2019-01-02 stsp {
153 0e673013 2019-01-02 stsp repo="$1"
154 0e673013 2019-01-02 stsp
155 0e673013 2019-01-02 stsp echo alpha > $repo/alpha
156 0e673013 2019-01-02 stsp echo beta > $repo/beta
157 0e673013 2019-01-02 stsp mkdir $repo/gamma
158 0e673013 2019-01-02 stsp echo delta > $repo/gamma/delta
159 0e673013 2019-01-02 stsp mkdir $repo/epsilon
160 0e673013 2019-01-02 stsp echo zeta > $repo/epsilon/zeta
161 0e673013 2019-01-02 stsp }
162 0e673013 2019-01-02 stsp
163 f6cae3ed 2020-09-13 naddy make_single_file_repo()
164 e7303626 2020-05-14 stsp {
165 e7303626 2020-05-14 stsp repo="$1"
166 e7303626 2020-05-14 stsp file="$2"
167 e7303626 2020-05-14 stsp
168 e7303626 2020-05-14 stsp mkdir $repo
169 e7303626 2020-05-14 stsp git_init $repo
170 e7303626 2020-05-14 stsp echo "this is file $file" > $repo/$file
171 e7303626 2020-05-14 stsp (cd $repo && git add .)
172 e7303626 2020-05-14 stsp git_commit $repo -m "intialize $repo with file $file"
173 e7303626 2020-05-14 stsp }
174 e7303626 2020-05-14 stsp
175 f6cae3ed 2020-09-13 naddy get_loose_object_path()
176 e7303626 2020-05-14 stsp {
177 e7303626 2020-05-14 stsp local repo="$1"
178 e7303626 2020-05-14 stsp local id="$2"
179 e7303626 2020-05-14 stsp local id0=`trim_obj_id 38 $id`
180 e7303626 2020-05-14 stsp local idrest=`echo ${id#[0-9a-f][0-9a-f]}`
181 e7303626 2020-05-14 stsp echo "$repo/.git/objects/$id0/$idrest"
182 e7303626 2020-05-14 stsp }
183 e7303626 2020-05-14 stsp
184 f6cae3ed 2020-09-13 naddy get_blob_id()
185 3ce1b845 2019-07-15 stsp {
186 3ce1b845 2019-07-15 stsp repo="$1"
187 3ce1b845 2019-07-15 stsp tree_path="$2"
188 3ce1b845 2019-07-15 stsp filename="$3"
189 3ce1b845 2019-07-15 stsp
190 e8863bdc 2020-07-23 stsp got tree -r $repo -i $tree_path | grep "[0-9a-f] ${filename}$" | \
191 e8863bdc 2020-07-23 stsp cut -d' ' -f 1
192 3ce1b845 2019-07-15 stsp }
193 3ce1b845 2019-07-15 stsp
194 f6cae3ed 2020-09-13 naddy test_init()
195 0e673013 2019-01-02 stsp {
196 0e673013 2019-01-02 stsp local testname="$1"
197 4a1ddfc2 2019-01-12 stsp local no_tree="$2"
198 0e673013 2019-01-02 stsp if [ -z "$testname" ]; then
199 0e673013 2019-01-02 stsp echo "No test name provided" >&2
200 0e673013 2019-01-02 stsp return 1
201 0e673013 2019-01-02 stsp fi
202 e5a14fe3 2020-10-01 stsp local testroot=`mktemp -d "$GOT_TEST_ROOT/got-test-$testname-XXXXXXXX"`
203 0e673013 2019-01-02 stsp mkdir $testroot/repo
204 0e673013 2019-01-02 stsp git_init $testroot/repo
205 4a1ddfc2 2019-01-12 stsp if [ -z "$no_tree" ]; then
206 4a1ddfc2 2019-01-12 stsp make_test_tree $testroot/repo
207 3ce1b845 2019-07-15 stsp (cd $repo && git add .)
208 4a1ddfc2 2019-01-12 stsp git_commit $testroot/repo -m "adding the test tree"
209 4a1ddfc2 2019-01-12 stsp fi
210 c8c71e6e 2020-03-21 stsp touch $testroot/repo/.git/git-daemon-export-ok
211 0e673013 2019-01-02 stsp echo "$testroot"
212 0e673013 2019-01-02 stsp }
213 0e673013 2019-01-02 stsp
214 f6cae3ed 2020-09-13 naddy test_cleanup()
215 0e673013 2019-01-02 stsp {
216 0e673013 2019-01-02 stsp local testroot="$1"
217 fe7842f5 2019-07-14 stsp
218 f0fd0aaf 2021-09-14 stsp git_fsck $testroot $testroot/repo
219 49c543a6 2022-03-31 naddy ret=$?
220 49c543a6 2022-03-31 naddy if [ $ret -ne 0 ]; then
221 f0fd0aaf 2021-09-14 stsp return $ret
222 fe7842f5 2019-07-14 stsp fi
223 fe7842f5 2019-07-14 stsp
224 0e673013 2019-01-02 stsp rm -rf "$testroot"
225 0e673013 2019-01-02 stsp }
226 0e673013 2019-01-02 stsp
227 f6cae3ed 2020-09-13 naddy test_parseargs()
228 7fb414ae 2020-08-08 stsp {
229 6c8da0c6 2020-10-03 naddy while getopts qr: flag; do
230 6c8da0c6 2020-10-03 naddy case $flag in
231 6c8da0c6 2020-10-03 naddy q) export GOT_TEST_QUIET=1
232 6c8da0c6 2020-10-03 naddy ;;
233 6c8da0c6 2020-10-03 naddy r) export GOT_TEST_ROOT=$OPTARG
234 6c8da0c6 2020-10-03 naddy ;;
235 6c8da0c6 2020-10-03 naddy ?) echo "Supported options:"
236 6c8da0c6 2020-10-03 naddy echo " -q: quiet mode"
237 6c8da0c6 2020-10-03 naddy echo " -r PATH: use PATH as test data root directory"
238 6c8da0c6 2020-10-03 naddy exit 2
239 6c8da0c6 2020-10-03 naddy ;;
240 7fb414ae 2020-08-08 stsp esac
241 7fb414ae 2020-08-08 stsp done
242 6c8da0c6 2020-10-03 naddy } >&2
243 7fb414ae 2020-08-08 stsp
244 f6cae3ed 2020-09-13 naddy run_test()
245 0e673013 2019-01-02 stsp {
246 0e673013 2019-01-02 stsp testfunc="$1"
247 7fb414ae 2020-08-08 stsp if [ -z "$GOT_TEST_QUIET" ]; then
248 7fb414ae 2020-08-08 stsp echo -n "$testfunc "
249 7fb414ae 2020-08-08 stsp fi
250 0e673013 2019-01-02 stsp $testfunc
251 0e673013 2019-01-02 stsp }
252 0e673013 2019-01-02 stsp
253 f6cae3ed 2020-09-13 naddy test_done()
254 0e673013 2019-01-02 stsp {
255 0e673013 2019-01-02 stsp local testroot="$1"
256 0e673013 2019-01-02 stsp local result="$2"
257 54c39596 2020-12-28 stsp if [ "$result" = "0" ]; then
258 fe7842f5 2019-07-14 stsp test_cleanup "$testroot" || return 1
259 7fb414ae 2020-08-08 stsp if [ -z "$GOT_TEST_QUIET" ]; then
260 7fb414ae 2020-08-08 stsp echo "ok"
261 7fb414ae 2020-08-08 stsp fi
262 3941b73a 2019-05-14 stsp elif echo "$result" | grep -q "^xfail"; then
263 3941b73a 2019-05-14 stsp # expected test failure; test reproduces an unfixed bug
264 3941b73a 2019-05-14 stsp echo "$result"
265 17201126 2019-07-14 stsp test_cleanup "$testroot" || return 1
266 0e673013 2019-01-02 stsp else
267 0e673013 2019-01-02 stsp echo "test failed; leaving test data in $testroot"
268 0e673013 2019-01-02 stsp fi
269 0e673013 2019-01-02 stsp }